function Fitness = Fit(PopObj,PopCon)

    N = size(PopObj,1);

    CV = sum(max(0,PopCon),2);

    Dominate = false(N);
    for i = 1 : N-1
        for j = i+1 : N
            if CV(i) < CV(j)
                Dominate(i,j) = true;
            elseif CV(i) > CV(j)
                Dominate(j,i) = true;
            else
                
                k = any( PopObj(i,:)<PopObj(j,:)) - any(PopObj(i,:)>PopObj(j,:) );
                if k == 1
                    Dominate(i,j) = true;
                elseif k == -1
                    Dominate(j,i) = true;
                end
            end
        end
    end
    
    S = sum(Dominate,2);
    
  
    R = zeros(1,N);
    for i = 1 : N
        R(i) = sum( S(Dominate(:,i)) );
    end
    
    %% Calculate D(i)
    Distance = pdist2(PopObj,PopObj);
    
    Distance(logical(    eye(length(Distance))      )) = inf;
    Distance = sort(Distance,2);
    D = 1./(Distance(:,floor(sqrt(N)))+2);
    
    %% Calculate the fitnesses
    Fitness = R + D';
end